
/////////////////////////////////////////////////////////////
//  Created by Zetta LLC @ AdobeScripting.com              //
//  Northfield MN, USA  Ph: 952-232-0211                   //
//  Email: Info@AdobeScripting.com                         //
//  Copyright: (c) 2015 Zetta LLC                          //
//  Authors:  Sandra Voelker   sandra@AdobeScripting.com   //
//            Sam Gannaway     sam@AdobeScripting.com      //
//  Original Creation date: July      2015                 //
/////////////////////////////////////////////////////////////

//---------------------------
function whatTool() {
    var ref = new ActionReference();
    ref.putProperty( charIDToTypeID( 'Prpr' ), charIDToTypeID( 'Tool' ) );
    ref.putEnumerated( charIDToTypeID( 'capp' ),  charIDToTypeID( 'Ordn' ), charIDToTypeID( 'Trgt' ) );
    var desc = executeActionGet( ref );
    var theTool = desc.getEnumerationType( charIDToTypeID( 'Tool' ) );
    var s = '<object>';
    var result = typeIDToStringID( theTool );
    s += PropertyToXML(result, 'tool');
    s += '</object>';
    return s;
}


//---------------------------
function getToolCharStringID(indescIDFromSWF)
{
    try {
        //convert the string from SWF to a number
        var id = Number(indescIDFromSWF); 
        var desc = new ActionDescriptor();
        desc.fromID(id);
        var idNull = charIDToTypeID('null');
        var ref = desc.getReference(idNull);
        var toolID = ref.getDesiredClass();
        //use this to compare against spotHealingBrushTool
        var stringID = typeIDToStringID(toolID); 
        //use this to compare against other tool codes
        var charID = typeIDToCharID(toolID); 
//        return (charID!=null && charID.length > 0) ? charID : stringID;;
        return [charID, stringID];
    }catch(err){
    }
}

//---------------------------
function ps_invoke_chc(url)
{
    var ad = new ActionDescriptor();
    ad.putString(stringIDToTypeID("helpID"), url); 
    executeAction(stringIDToTypeID("helpLauncher"), ad, DialogModes.NO);
}

function invoke_script_file(extPath, relativeFilepath) {		// filepath is relative to functions.jsx
		try {
	        var scriptFile =  File.decode (extPath + '/jsx/' + relativeFilepath);
			var f = new File(scriptFile);
		    if (f.exists) {
				$.evalFile(f, 300000);
		    } else {
		  	alert("File does not exist: " + scriptFile);
		    }
		}catch(err){
			alert(err);
		}
	};


//---------------------------
function invoke_function_in_script_file(filepath, ns, functionName, arguments) {
}
function invoke_script(script)
{
}
function ps_invoke_script(script)
{
}
//---------------------------
function ps_invoke_action(actionSet, actionName)
{
//  var action = decode(actionName);
//  var group = decode(actionSet);
//  writelog("invoke action " + action + " " + group);
  ErrStrs = {}; 
  ErrStrs.USER_CANCELLED=localize("$$$/ScriptingSupport/Error/UserCancelled=User cancelled the operation"); 
  try 
  {
      app.doAction(actionName, actionSet);
//      app.doAction(action, group);
    } 
    catch(e)
    {
        if (e.toString().indexOf(ErrStrs.USER_CANCELLED)!=-1) {;} 
        else
        {
            alert(actionSet + " : "+actionName + "\n" + localize("$$$/ScriptingSupport/Error/CommandNotAvailable=The command is currently not available"));
        }    
    }
}
//---------------------------
function ps_invoke_scritps_menu_item(item)
{
    var idAdobeScriptAutomationScripts = stringIDToTypeID( "AdobeScriptAutomation Scripts" );
    var desc2 = new ActionDescriptor();
    var idjsNm = charIDToTypeID( "jsNm" );
    desc2.putString( idjsNm, item ); // string for name of script in menu
    var idjsMs = charIDToTypeID( "jsMs" );
    desc2.putString( idjsMs, "undefined" );
    executeAction( idAdobeScriptAutomationScripts, desc2, DialogModes.NO );
}
//---------------------------
function invoke_feature_by_id(id)
{
    //alert("invoke feature by id " + id);
    $.evalFile(assetsPath + "/bundles/PHSP-14/feature.jsx");
    eval(id + "()");
}



function Main_Select_Refine_Edge()
{
ErrStrs = {};
 ErrStrs.USER_CANCELLED=localize("$$$/ScriptingSupport/Error/UserCancelled=User cancelled the operation");
 try {var idrefineSelectionEdge = stringIDToTypeID( 'refineSelectionEdge' );
 executeAction( idrefineSelectionEdge, undefined, DialogModes.ALL );
 } catch(e){if (e.toString().indexOf(ErrStrs.USER_CANCELLED)!=-1) {;
} else{alert(localize("$$$/ScriptingSupport/Error/CommandNotAvailable=The command is currently not available"));
}}}

function Main_Filter_Noise_Reduce_Noise()
{
ErrStrs = {};
 ErrStrs.USER_CANCELLED=localize("$$$/ScriptingSupport/Error/UserCancelled=User cancelled the operation");
 try {var iddenoise = stringIDToTypeID( 'denoise' );
 executeAction( iddenoise, undefined, DialogModes.ALL );
 } catch(e){if (e.toString().indexOf(ErrStrs.USER_CANCELLED)!=-1) {;
} else{alert(localize("$$$/ScriptingSupport/Error/CommandNotAvailable=The command is currently not available"));
}}}

